unit DE41u1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    buquit: TButton;
    buSpecSource: TButton;
    buSpecDest: TButton;
    buSpecCrit: TButton;
    buDoIt: TButton;
    procedure FormCreate(Sender: TObject);
    procedure buquitClick(Sender: TObject);
    procedure buSpecSourceClick(Sender: TObject);
    procedure buSpecDestClick(Sender: TObject);
    procedure buSpecCritClick(Sender: TObject);
    procedure buDoItClick(Sender: TObject);
  private
    { Private declarations }
    dfIn,dfOut:textfile;//file "handles" See http://sheepdogguides.com/dt2b.htm
       //for help with the ideas, if needed.
    wDate:word;
       //Will store the day, in Delphi's coding, which defines the boundary
       //between lines I want copied and those I don't want.
       //Will allow me about 30,000 days after 1/1/1996 before the
       //program has "Year 2000" problems.
       //(Word type data can hold 0-65535, the Delphi "name" for
       // 1/1/1996 was 35,065)
    boDFOutIsOpen,boDFInIsOpen:boolean;//see text published on
       //internet in connection with this application if the purpose
       //of these variables escapes you.
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
(*Next two lines cause application to open in a "sensible" position
  regardless of the resolution the user's screen is set to.
  All of the properties referenced, e.g. screen.height, are built
  in to the ordinary Delphi environment.

  Having these two lines in the code means that the form can be
  wherever you find it most convenient on your desktop while
  developiung the application*)
top:=(screen.height div 3)-(clientheight div 2);
left:=(screen.width div 2)-(clientwidth div 2);
(*"Turn off" some buttons. Could be done with Object Inspector, but
   the fact they start "off" is clearer if it is done this way.*)
buSpecDest.enabled:=false;
buSpecCrit.enabled:=false;
buDoIt.enabled:=false;
//See text published on internet if you want to know more
//about the next two... or use your editor to scan through
//the lines where they appear....
boDFInIsOpen:=false;
boDFOutIsOpen:=false;
end;

procedure TForm1.buquitClick(Sender: TObject);
begin
close;
end;

procedure TForm1.buSpecSourceClick(Sender: TObject);
//CAUTION: VERY CRUDE: Doesn't check to see if
//   ther IS a C:\TmpTest.txt to open!
(*Open source file, with DFIn as handle to it.*)
begin
if boDFInIsOpen then closefile(dfIn);//In case user has clicked on SpecSource before!
assignfile(dfIn,'C:\TmpTest.txt');
reset(dfIn);
//if dfIn is an empty file, application needs to refuse to proceed
boDFInIsOpen:=true;
//Now enable button for next step..
buSpecDest.enabled:=true;
end;

procedure TForm1.buSpecDestClick(Sender: TObject);
//CAUTION: VERY CRUDE: WILL OVERWRITE ANY PRE-EXISTING
//   C:\TmpTestOut.txt WITHOUT WARNING
(*Open destination file, with DFOut as handle to it.
  Will need to deal with what user wants if file
  already exists when application is run. While
  not implemented here, code can be written
  to allow the protection of an existing
  files contents, or even open the file
  in such a way that the old contents remain
  and this application adds new material to
  the end of the file. ("Append")*)
begin
if boDFOutIsOpen then closefile(dfOut);//In case user has clicked on SpecSource before!
assignfile(dfOut,'C:\TmpTestOut.txt');
rewrite(dfOut);
boDFOutIsOpen:=true;
//Now enable button for next step..
buSpecCrit.enabled:=true;
end;

procedure TForm1.buSpecCritClick(Sender: TObject);
(*Fills wDate with the day which is the last for
which I do NOT want lines copied.*)
begin
wDate:=trunc(now)-7;
(*"Now" is a built in Delphi function.
  int(now) gives me the date, in Delphi's coding.
  See the place where wDate was declared for more information*)
//Now enable button for next step..
buDoIt.enabled:=true;
end;

procedure TForm1.buDoItClick(Sender: TObject);
//Variables used only within this procedure.
//As such, they are best declared WITHIN it.
var sLineJustRead:string;
    boFileEmpty:boolean;

//Note that the following function is made a
//part of the buDoItClick procdure. It isn't
//needed elsewhere, so there is no reason
//for it to be created at a higher level.
function boLineIsWanted(sTmp:string):boolean;
//A crude "placeholder". In this form,
//it will return false until the
//first letter of the line passed
//to it is something other than
//an "O". (The first line in my
//test data started with an "O".)
begin
result:=false;
if sTmp[1]<>'O' then result:=true;
end;


begin (*Start of buDoItClick's main block*)
//Write header to destination
writeln(dfOut,'This file created by DE41');

repeat //"Repeat" in our outline!
//---- read a line of source
readln(dfIn,sLineJustRead);
//---- set boFileEmpty... remember we discovered that
//    eof returns true after last datum read, it isn't
//    necessary to try to read past the end to get
//    "true" from eof
boFileEmpty:=eof(dfIn);
//Until a line wanted for destination is found, or boFileEmpty is true
until boFileEmpty or boLineIsWanted(sLineJustRead);
(*We've now made a good start, and got to the point where we
  now want to copy the rest of the source file to the destination*)
//While not boFileEmpty, do...
while not boFileEmpty do begin
//---- Write line to destination
writeln(dfOut,sLineJustRead);
//---- Read another line
readln(dfIn);
//---- Update the value in boFileEmpty
boFileEmpty:=eof(dfIn);
end;//of while loop
//Write last line out to destination
writeln(dfOut,sLineJustRead);
//Close files
closefile(dfIn);
  boDFInIsOpen:=false;
closefile(dfOut);
  boDFOutIsOpen:=false;
showmessage('Done!');//Always tell the user all went well.
end;

end.
